"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _apex = _interopRequireDefault(require("apex.js"));

var _contextJs = _interopRequireDefault(require("@tleef/context-js"));

var _logJs = require("@tleef/log-js");

var env = process.env.ENV;
console.log('Loading function');
console.log('Env:', env);

var _default = function _default(fn, onError) {
  var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return (0, _apex.default)(function (event, context) {
    var logger = config.logger || _logJs.main;
    var ctx = new _contextJs.default().set('id', context.awsRequestId).withValues({
      lambda: {
        event: event,
        context: context
      }
    });
    var processingMeta = {
      request_id: ctx.id
    };

    if (config.printEvent) {
      processingMeta.event = event;
    }

    logger.log('processing event', processingMeta);
    return new Promise(
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(resolve, reject) {
        var res, errorMeta, resMeta;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return fn(ctx, event);

              case 3:
                res = _context.sent;
                _context.next = 15;
                break;

              case 6:
                _context.prev = 6;
                _context.t0 = _context["catch"](0);
                errorMeta = {
                  request_id: ctx.id
                };

                if (config.printError) {
                  errorMeta.error = _context.t0.message;
                }

                logger.log('error while processing', errorMeta);
                res = onError(ctx, _context.t0);

                if (!config.rejectOnError) {
                  _context.next = 15;
                  break;
                }

                reject(res);
                return _context.abrupt("return");

              case 15:
                resMeta = {
                  request_id: ctx.id
                };

                if (config.printResponse) {
                  resMeta.response = res;
                }

                logger.log('responding', resMeta);
                resolve(res);

              case 19:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 6]]);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
  });
};

exports.default = _default;